package net.awired.ajsl.persistence.dao;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;
import javax.persistence.EntityNotFoundException;
import net.awired.ajsl.persistence.entity.Activable;
import net.awired.ajsl.persistence.entity.Archivable;
import net.awired.ajsl.persistence.entity.IdEntity;

public interface ReadDAO<ENTITY extends IdEntity<KEY>, KEY extends Serializable> {

    ENTITY find(KEY id) throws EntityNotFoundException;

    /**
     * find by ids with default flags : {@link Archivable} = false if exists {@link Activable} = true
     */
    List<ENTITY> find(KEY[] ids);

    //    List<ENTITY> find(KEY[] ids, Class<?>... flags);

    List<ENTITY> find(Collection<KEY> ids);

    List<ENTITY> find(Collection<KEY> ids, Class<?>... flags);

    List<ENTITY> findAll();

    //    List<ENTITY> findAll(Class<?>... flags);

    void refresh(ENTITY entity);

}
